C Subroutine Allocation 3/31/2000
	SUBROUTINE Alloc(i,what,mass,Sink,Source,SuL,SuS,SuR,vL,vS,vR,
     +		d13Cps,d13CstL,d13CstS,d13CstR,d13Celli,d13Celli1,d13Ci1,
     +		dDps,dDstL,dDstS,dDstR,dDelli,dDelli1,dDi1,
     +		d18Ops,d18OstL,d18OstS,d18OstR,d18Oelli,d18Oelli1,d18Oi1,
     +		d13CstLAr,d13CstSAr,d13CstRAr,dDstLAr,dDstSAr,dDstRAr,
     +		d18OstLAr,d18OstSAr,d18OstRAr,SuLAr,SuSAr,SuRAr)
C  *****************************************************************************
CC  Allocates and updates photosynthate and/or stored starch depending on 
CC  growth.  If stem is being considered priority of carbohydrate allocation is: 
CC  1) Present photosynthate, 2) Stored starch in stem, 3) Stored starch in Leaf 
CC  and Root (proportioned according to relative reserves). If leaf or root is 
CC  being considered priority is 1) present photosynthate, 2) starch at location 
CC  and 3) stem starch.
C  *****************************************************************************
	CHARACTER*4 what
	REAL  mass,propmass,y
	REAL  Sink,Source,SuL,SuS,SuR,Sui,Sui1
	REAL  d13Cps,d13CstL,d13CstS,d13CstR
	REAL  d13Csti,d13Ci1,d13Celli,d13Celli1
	REAL  dDps,dDstL,dDstS,dDstR
	REAL  dDsti,dDi1,dDelli,dDelli1
	REAL  d18Ops,d18OstL,d18OstS,d18OstR
	REAL  d18Osti,d18Oi1,d18Oelli,d18Oelli1
	REAL  propSu,SuA,SuB,vL,vS,vR,vA,vB
	REAL  SuLAr(366),SuSAr(366),SuRAr(366)
	REAL  d13CstLAr(366),d13CstSAr(366),d13CstRAr(366)
	REAL  dDstLAr(366),dDstSAr(366),dDstRAr(366)
	REAL  d18OstLAr(366),d18OstSAr(366),d18OstRAr(366)
C  *****************************************************************************
CC  Resp=Maintainance respiration
CC  Sink=Used photosynthate or storage ie. growth rate or respiration
CC  Source=Current photosynthate ie. may be after respiration
CC  vL,vS,vR=Volume of active cells in leaf,stem and root
CC  vA,vB=Volume of active cells in compartment A and B (leaf,stem or root)
CC  SuL,SuS,SuR=Starch in leaves,stem,root
CC  Sui=Sucrose in compartment at time i
CC  Sui1=Sucrose in compartment at time i+1
CC  d13Cps=d13C of current photosynthate
CC  d13CstL,d13CstS,d13CstR=d13C of starch in leaf,stem,root
CC  d13Csti=d13C of stored starch at time i
CC  d13Ci1=d13C of additional structural components at time i+1
CC  d13Celli=d13C of structural components at time i
CC  d13Celli1=d13C of structural components at time i+1
C  *****************************************************************************
c	
      SuLAr(i)=SuL
	SuSAr(i)=SuS
	SuRAr(i)=SuR
c
	d13CstLAr(i)=d13Cps
	d13CstSAr(i)=d13Cps
	d13CstRAr(i)=d13Cps
c
	dDstLAr(i)=dDps
	dDstSAr(i)=dDps
	dDstRAr(i)=dDps
c
	d18OstLAr(i)=d18Ops
	d18OstSAr(i)=d18Ops
	d18OstRAr(i)=d18Ops
c
	IF (Sink.GE.0.0) THEN
	IF (what.EQ.'leaf') THEN
		Sui=SuL
		SuA=SuS
		vA=vS
		SuB=0.1
		d13CstA=d13CstS
		d13Csti=d13CstL
C ********
		dDstA=dDstS
		dDsti=dDstL
		d18OstA=d18OstS
		d18Osti=d18OstL
C ********
		ELSEIF (what.EQ.'stem') THEN
			Sui=SuS
			SuA=SuL
			vA=vL
			d13CstA=d13CstL
			SuB=SuR
			vB=vR
			d13CstB=d13CstR
			d13Csti=d13CstS
C ********
			dDstA=dDstL  
			dDstB=dDstR
			dDsti=dDstS
			d18OstA=d18OstL 
			d18OstB=d18OstR
			d18Osti=d18OstS
C ********
			ELSE
				Sui=SuR
				SuA=0.1
				SuB=SuS
				vB=vS
				d13CstB=d13CstS
				d13Csti=d13CstR
C ********
				dDstB=dDstS
				dDsti=dDstR
				d18OstB=d18OstS
				d18Osti=d18OstR
C ********
	ENDIF
C
	IF (Sink.LE.Source) THEN
		d13Ci1=d13Cps
C **********
		dDi1=dDps 
		d18Oi1=d18Ops 
C **********
		Sui1=Sui
	    Source=Source-Sink
		ELSEIF ((Sui+Source).GT.Sink) THEN
	        y=Sink-Source
		    CALL dStNew(i,y,what,SuLAr,SuSAr,SuRAr,d13CstLAr,
     +				  d13CstSAr,d13CstRAr,dDstLAr,dDstSAr,dDstRAr,
     +				  d18OstLAr,d18OstSAr,d18OstRAr,d13Csti,dDsti,
     +				  d18Osti)
			d13Ci1=d13Cps*(Source/Sink)+d13Csti*
     +				(1-(Source/Sink))
C **********
			dDi1=dDps*(Source/Sink)+dDsti*
     +				(1-(Source/Sink))
			d18Oi1=d18Ops*(Source/Sink)+d18Osti*
     +				(1-(Source/Sink))
C **********
			Sui1=Sui+(Source-Sink)
			Source=0.0
			ELSE ! Never gets called...code not checked
	            y=(Sink-Source-Sui)
				propSu=(SuA/vA)/((SuA/vA)+(SuB/vB))
				changeA=y*propSu
				changeB=y*(1-propSu)
				IF (changeA.GE.SuA) THEN
					changeA=SuA
					changeB=y-SuA
					IF(changeB.GE.SuB)Sink=SuA+SuB+Sui+Source 	
					ELSEIF(changeB.GE.SuB) THEN
						changeA=1-SuB
						changeB=SuB
						IF(changeA.GE.SuA)Sink=SuA+SuB+Sui+Source 	
				ENDIF
				SuA=MAX(0.0,SuA-changeA)
				SuB=MAX(0.0,SuB-changeB)
				CALL dStNew(i,y,what,SuLAr,SuSAr,SuRAr,d13CstLAr,
     +				    d13CstSAr,d13CstRAr,dDstLAr,dDstSAr,dDstRAr,
     +				    d18OstLAr,d18OstSAr,d18OstRAr,d13Csti,dDsti,
     +				    d18Osti)	
			    d13Ci1=d13Cps*Source/Sink+d13Csti*Sui/Sink
     +			+d13CstA*changeA/Sink+d13CstB*changeB/Sink
C *********
			    dDi1=dDps*Source/Sink+dDsti*Sui/Sink
     +			+dDstA*changeA/Sink+dDstB*changeB/Sink
			    d18Oi1=d18Ops*Source/Sink+d18Osti*Sui/Sink
     +			+d18OstA*changeA/Sink+d18OstB*changeB/Sink
C *********
				Sui1=0.0
	            Source=0.0
	ENDIF
		propmass=Sink/(mass+Sink)
		d13Celli1=(d13Celli*(1-propmass))+(d13Ci1*propmass)
C *********
		dDelli1=(dDelli*(1-propmass))+(dDi1*propmass)
		d18Oelli1=(d18Oelli*(1-propmass))+(d18Oi1*propmass)
C *********
	IF (what.EQ.'leaf') THEN
		SuL=Sui1
		SuS=SuA
		ELSEIF (what.EQ.'stem') THEN
			SuS=Sui1
			SuL=SuA
			SuR=SuB
			ELSE
				SuR=Sui1
				SuS=SuB
	ENDIF
	ELSE
		d13Celli1=d13Celli
		dDelli1=dDelli
		d18Oelli1=d18Oelli
      ENDIF
	RETURN
	END

	SUBROUTINE dStNew(i,y,what,SuLAr,SuSAr,SuRAr,d13CstLAr,d13CstSAr,
     +				 d13CstRAr,dDstLAr,dDstSAr,dDstRAr,d18OstLAr,
     +				 d18OstSAr,d18OstRAr,d13Csti,dDsti,d18Osti)
C  *****************************************************************************
CC  
C  *****************************************************************************
	CHARACTER*4 what
	REAL  y,extra,tot,SuLAr(366),SuSAr(366),SuRAr(366)
	REAL  d13Csti,d13CstLAr(366),d13CstSAr(366),d13CstRAr(366)
	REAL  dDsti,dDstLAr(366),dDstSAr(366),dDstRAr(366)
	REAL  d18Osti,d18OstLAr(366),d18OstSAr(366),d18OstRAr(366)
	INTEGER i,j,k
	tot=0.0
	tot1=0.0
	DO j=i,1,-1
		IF (what.EQ.'leaf') THEN
		  IF (j.GT.1) THEN
		    IF (SuLAr(j).GT.SuLAr(j-1)) THEN
			  tot1=tot+(SuLAr(j)-SuLAr(j-1))
			ELSE
			  tot1=tot
			ENDIF
	      ELSE
			tot1=tot+SuLAr(j)
	      ENDIF
		ENDIF
		IF (what.EQ.'stem') THEN
		  IF (j.GT.1) THEN
		    IF (SuSAr(j).GT.SuSAr(j-1)) THEN
			  tot1=tot+(SuSAr(j)-SuSAr(j-1))
	        ELSE
			  tot1=tot
			ENDIF
		  ELSE
			tot1=tot+SuSAr(j)
	      ENDIF
		ENDIF
		IF (what.EQ.'root') THEN
		  IF (j.GT.1) THEN 
		    IF (SuRAr(j).GT.SuRAr(j-1)) THEN
			  tot1=tot+(SuRAr(j)-SuRAr(j-1))
			ELSE
			  tot1=tot
			ENDIF
	      ELSE
			tot1=tot+SuRAr(j)
	      ENDIF
		ENDIF
		IF (tot1.GE.y) THEN
			IF (what.EQ.'leaf') THEN
			  extra=y-tot
			  d13Csti=d13CstLAr(j)*(extra/y)
			  dDsti=dDstLAr(j)*(extra/y)
			  d18Osti=d18OstLAr(j)*(extra/y)
			  SuLAr(j)=SuLAr(j)-extra
			  DO k=j+1,i 
			   IF (SuLAr(k).GT.SuLAr(k-1)) THEN
				d13Csti=d13Csti+d13CstLAr(k)*((SuLAr(k)-SuLAr(k-1))/y)
				dDsti=dDsti+dDstLAr(k)*((SuLAr(k)-SuLAr(k-1))/y)
				d18Osti=d18Osti+d18OstLAr(k)*((SuLAr(k)-SuLAr(k-1))/y)
				SuLAr(j)=0.0
			   ENDIF
			  END DO
			ENDIF
			IF (what.EQ.'stem') THEN
			  extra=y-tot
			  d13Csti=d13CstSAr(j)*(extra/y)
			  dDsti=dDstSAr(j)*(extra/y)
			  d18Osti=d18OstSAr(j)*(extra/y)
			  SuSAr(j)=SuSAr(j)-extra
			  DO k=j+1,i 
			   IF (SuSAr(k).GT.SuSAr(k-1)) THEN
				d13Csti=d13Csti+d13CstSAr(k)*((SuSAr(k)-SuSAr(k-1))/y)
				dDsti=dDsti+dDstSAr(k)*((SuSAr(k)-SuSAr(k-1))/y)
				d18Osti=d18Osti+d18OstSAr(k)*((SuSAr(k)-SuSAr(k-1))/y)
				SuSAr(j)=0.0
			   ENDIF
			  END DO
			ENDIF
			IF (what.EQ.'root') THEN
			  extra=y-tot
			  d13Csti=d13CstRAr(j)*(extra/y)
			  dDsti=dDstRAr(j)*(extra/y)
			  d18Osti=d18OstRAr(j)*(extra/y)
			  SuRAr(j)=SuRAr(j)-extra
			  DO k=j+1,i
			   IF (SuRAr(k).GT.SuRAr(k-1)) THEN
				d13Csti=d13Csti+d13CstRAr(k)*((SuRAr(k)-SuRAr(k-1))/y)
				dDsti=dDsti+dDstRAr(k)*((SuRAr(k)-SuRAr(k-1))/y)
				d18Osti=d18Osti+d18OstRAr(k)*((SuRAr(k)-SuRAr(k-1))/y)
				SuRAr(j)=0.0
			   ENDIF
			  END DO
			ENDIF
		GOTO 10
		ENDIF
	tot=tot1		
  	END DO
  10	RETURN
	END


	SUBROUTINE Redis(i,Ps,SuL,SuS,SuR,vL,vS,vR,rate,d13Cps,dDps,
     +                d18Ops,d13CstL,d13CstS,d13CstR,dDstL,dDstS,dDstR,
     +				d18OstL,d18OstS,d18OstR,FinalPs,
     +			d13CstLAr,d13CstSAr,d13CstRAr,dDstLAr,dDstSAr,dDstRAr,
     +			d18OstLAr,d18OstSAr,d18OstRAr,SuLAr,SuSAr,SuRAr)
C
	REAL SuL(366),SuS(366),SuR(366),vL,vS,vR,rate
	REAL d13Cps,d13CstL(366),d13CstS(366),d13CstR(366)
	REAL dDps,dDstL(366),dDstS(366),dDstR(366)
	REAL d18Ops,d18OstL(366),d18OstS(366),d18OstR(366)
	REAL Ps,ConcSuL,ConcSuS,ConcSuR,FinalPs
	REAL PropSuL,PropSuS,PropSuR,tot,tot1
	REAL d13CstLAr(366),d13CstSAr(366),d13CstRAr(366)
	REAL dDstLAr(366),dDstSAr(366),dDstRAr(366)
	REAL d18OstLAr(366),d18OstSAr(366),d18OstRAr(366)
	REAL  SuLAr(366),SuSAr(366),SuRAr(366)
C  *****************************************************************************
CC  Redistributes remaining photosynthate at end of each day. The concentration 
CC  of this photosynthate is calculated as a proportion of the total volume of
CC  active cells ie. sapwood etc. The concentration of starch in each location
CC  is then calculated. The excess photosynthate is allocated AT A SET RATE (rate)
CC  to each of the storage locations in proportions relative to the concentrations
CC  of starch previously in those locations.
C  *****************************************************************************
	ConcSuL=vL/SuL(i) ! Inverse concentration of Su, ie. Sink strength for allocation
	ConcSuS=vS/SuS(i)
	ConcSuR=vR/SuR(i)
	PropSuL=ConcSuL/(ConcSuL+ConcSuS+ConcSuR)
	PropSuS=ConcSuS/(ConcSuL+ConcSuS+ConcSuR)
	PropSuR=ConcSuR/(ConcSuL+ConcSuS+ConcSuR)

	SuL(i+1)=SuL(i)+rate*Ps*PropSuL ! Amount of cumulated starch in each pool
	SuS(i+1)=SuS(i)+rate*Ps*PropSuS
	SuR(i+1)=SuR(i)+rate*Ps*PropSuR

c	SuNewL(i)=SuLi-SuL ! Amount of stored starch added on day i
c	SuNewS(i)=SuSi-SuS
c	SuNewR(i)=SuRi-SuR

	FinalPs=(1-rate)*Ps ! remaining photosynthate in tree

	d13CstL(i)=d13CstL(i)*(SuL(i)/SuL(i+1))+d13Cps*(1-SuL(i)/SuL(i+1))
	d13CstS(i)=d13CstS(i)*(SuS(i)/SuS(i+1))+d13Cps*(1-SuS(i)/SuS(i+1))
	d13CstR(i)=d13CstR(i)*(SuR(i)/SuR(i+1))+d13Cps*(1-SuR(i)/SuR(i+1))

	dDstL(i)=dDstL(i)*(SuL(i)/SuL(i+1))+dDps*(1-SuL(i)/SuL(i+1))
	dDstS(i)=dDstS(i)*(SuS(i)/SuS(i+1))+dDps*(1-SuS(i)/SuS(i+1))
	dDstR(i)=dDstR(i)*(SuR(i)/SuR(i+1))+dDps*(1-SuR(i)/SuR(i+1))

	d18OstL(i)=d18OstL(i)*(SuL(i)/SuL(i+1))+d18Ops*(1-SuL(i)/SuL(i+1))
	d18OstS(i)=d18OstS(i)*(SuS(i)/SuS(i+1))+d18Ops*(1-SuS(i)/SuS(i+1))
	d18OstR(i)=d18OstR(i)*(SuR(i)/SuR(i+1))+d18Ops*(1-SuR(i)/SuR(i+1))

	signL=vL*(SuL(i+1)+SuS(i+1)+SuR(i+1))/(vL+vS+vR)-SuL(i+1)
	signS=vS*(SuL(i+1)+SuS(i+1)+SuR(i+1))/(vL+vS+vR)-SuS(i+1)
	signR=vR*(SuL(i+1)+SuS(i+1)+SuR(i+1))/(vL+vS+vR)-SuR(i+1)

	IF (signL.LT.0.0) THEN
		IF (signS.LT.0.0) THEN
			d13CstR(i)=(d13CstR(i)*SuR(i+1)+d13CstL(i)*ABS(signL)+
     +				d13CstS(i)*ABS(signS))/(SuR(i+1)+signR)
			dDstR(i)=(dDstR(i)*SuR(i+1)+dDstL(i)*ABS(signL)+
     +				dDstS(i)*ABS(signS))/(SuR(i+1)+signR)
			d18OstR(i)=(d18OstR(i)*SuR(i+1)+d18OstL(i)*ABS(signL)+
     +				d18OstS(i)*ABS(signS))/(SuR(i+1)+signR)
		ELSEIF (signR.LT.0.0) THEN
			d13CstS(i)=(d13CstS(i)*SuS(i+1)+d13CstL(i)*ABS(signL)+
     +				d13CstR(i)*ABS(signR))/(SuS(i+1)+signS)
			dDstS(i)=(dDstS(i)*SuS(i+1)+dDstL(i)*ABS(signL)+
     +				dDstR(i)*ABS(signR))/(SuS(i+1)+signS)
			d18OstS(i)=(d18OstS(i)*SuS(i+1)+d18OstL(i)*ABS(signL)+
     +				d18OstR(i)*ABS(signR))/(SuS(i+1)+signS)
		ELSE
			d13CstS(i)=(d13CstS(i)*SuS(i+1)+d13CstL(i)*signS)/
     +												(SuS(i+1)+signS)
			d13CstR(i)=(d13CstR(i)*SuR(i+1)+d13CstL(i)*signR)/
     +												(SuR(i+1)+signR)
			dDstS(i)=(dDstS(i)*SuS(i+1)+dDstL(i)*signS)/
     +												(SuS(i+1)+signS)
			dDstR(i)=(dDstR(i)*SuR(i+1)+dDstL(i)*signR)/
     +												(SuR(i+1)+signR)
			d18OstS(i)=(d18OstS(i)*SuS(i+1)+d18OstL(i)*signS)/
     +												(SuS(i+1)+signS)
			d18OstR(i)=(d18OstR(i)*SuR(i+1)+d18OstL(i)*signR)/
     +												(SuR(i+1)+signR)
		ENDIF
	ELSE
			IF (signS.LT.0.0) THEN
				IF (signR.LT.0.0) THEN
					d13CstL(i)=(d13CstL(i)*SuL(i+1)+d13CstS(i)*
     +ABS(signS)+d13CstR(i)*ABS(signR))/(SuL(i+1)+signR+signS)
					dDstL(i)=(dDstL(i)*SuL(i+1)+dDstS(i)*
     +ABS(signS)+dDstR(i)*ABS(signR))/(SuL(i+1)+signR+signS)
					d18OstL(i)=(d18OstL(i)*SuL(i+1)+d18OstS(i)*
     +ABS(signS)+d18OstR(i)*ABS(signR))/(SuL(i+1)+signR+signS)
				ELSE
					d13CstL(i)=(d13CstL(i)*SuL(i+1)+d13CstS(i)*signL)/
     +												(SuL(i+1)+signL)
					d13CstR(i)=(d13CstR(i)*SuR(i+1)+d13CstS(i)*signR)/
     +												(SuR(i+1)+signR)
					dDstL(i)=(dDstL(i)*SuL(i+1)+dDstS(i)*signL)/
     +												(SuL(i+1)+signL)
					dDstR(i)=(dDstR(i)*SuR(i+1)+dDstS(i)*signR)/
     +												(SuR(i+1)+signR)
					d18OstL(i)=(d18OstL(i)*SuL(i+1)+d18OstS(i)*signL)/
     +												(SuL(i+1)+signL)
					d18OstR(i)=(d18OstR(i)*SuR(i+1)+d18OstS(i)*signR)/
     +												(SuR(i+1)+signR)
				ENDIF
			ELSE
				d13CstL(i)=(d13CstL(i)*SuL(i+1)+d13CstR(i)*signL)/
     +												(SuL(i+1)+signL)
				d13CstS(i)=(d13CstS(i)*SuS(i+1)+d13CstR(i)*signS)/
     +												(SuS(i+1)+signS)
				dDstL(i)=(dDstL(i)*SuL(i+1)+dDstR(i)*signL)/
     +												(SuL(i+1)+signL)
				dDstS(i)=(dDstS(i)*SuS(i+1)+dDstR(i)*signS)/
     +												(SuS(i+1)+signS)
				d18OstL(i)=(d18OstL(i)*SuL(i+1)+d18OstR(i)*signL)/
     +												(SuL(i+1)+signL)
				d18OstS(i)=(d18OstS(i)*SuS(i+1)+d18OstR(i)*signS)/
     +												(SuS(i+1)+signS)
			ENDIF
	ENDIF
	SuL(i+1)=SuL(i+1)+signL
	SuS(i+1)=SuS(i+1)+signS
	SuR(i+1)=SuR(i+1)+signR
c
	d13CstLAr(i)=(d13CstLAr(i)*0.5)+(d13CstL(i)*0.5)
	d13CstSAr(i)=(d13CstLAr(i)*1.0)+(d13CstL(i)*0.0)
	d13CstRAr(i)=(d13CstLAr(i)*0.5)+(d13CstL(i)*0.5)
c
	dDstLAr(i)=(dDstLAr(i)*0.6)+(dDstL(i)*0.4)
	dDstSAr(i)=(dDstLAr(i)*0.6)+(dDstL(i)*0.4)
	dDstRAr(i)=(dDstLAr(i)*0.6)+(dDstL(i)*0.4)
c
	d18OstLAr(i)=(d18OstLAr(i)*1.0)+(d18OstL(i)*0.0)
	d18OstSAr(i)=(d18OstLAr(i)*0.5)+(d18OstL(i)*0.5)
	d18OstRAr(i)=(d18OstLAr(i)*1.0)+(d18OstL(i)*0.0)
c
	RETURN
	END
