c      4/18/2000
	SUBROUTINE MCLIMAT(Temp,Prec,DewPt,isoO,isoH,dDprec,d18Oprec,dDvap
     +	    ,d18Ovap,trp,Rad,Dlen,hemisphere,clfile,lat,alt,M1,M2,Rmin
     +        ,op,e,es,Tmax,cons)
c Ŀ
c program read file with climatic data                                 
c format: Ĵ
c Stationsname        Lati.Long.Alti.                                  
c D  Mo Year Max. Min.Mean  Sunshine     Daily          Mean      
c *         Temp.Temp.Cloud Abs. Rel.Prec.TransPressTemp.Humi
c *                   Cover                    /             
c *         /10 C/10 C/10  /10 h  %  /10mm/10mm10hPa/10 C  % 
c Year(I4)                                                     
c LAT LON ALT (3I6)                                            
c XX XX XXXXXXXX XXXX XXXX XXXX XXXX XXXX XXXX XXXX XXXX XXXX
c Ĵ
c Temp()   - Temperature                (celcius)                      
c Prec()   - Precipitation              (mm/day) 
c DewPt()  - Dew Point Temperature      (celcius)                      
c			If no Dew Point Temp. available Td=0.7091*(Tmin)-0.9384
c wddef()  - the water-density  deficit (kg/m^3)
c lat      - Latitude                   (deg, output-rad)              
c clfile   - name of climatic file      (path+filename)                
c M1,M2    - period of avalable clim data                              
c                                                                      
c 
CC Returns: the average temperature (Temp),[C]
CC          precipitation (Prec) in       [mm/day  ]
CC          potential transpiration (trp) [kg/m^2/h]
CC          day length (Dlen)             [h]
CC          average irradiation (Rad)     [MJ/m^2/day]

      REAL           Temp(366), prec(366),trp(366),
     +               Rad(366),  Dlen(366), cons(20)
      REAL           Temp1(366), Prec1(366),wddef(366),
     +               trp1(366), Tmax(366), Tmin(366),
     +               Rad1(366),  Dlen1(366), DewPt(366)
      REAL           lat,e(366),es(366),isoO(15),isoH(15),
     +			   d18Oprec(366),d18Ovap(366),dDprec(366),dDvap(366)
      CHARACTER      clfile*60, fc*30, hemisphere*1
      INTEGER op(40),alt,TmaxF(366),TminF(366),chk,pchk
CC Read Microclimate constants
      OPEN(10,FILE='Mcconst.cst',ERR=10)
	DO i=1,20
        READ(10,'(F12.3)')cons(i)
	ENDDO
      CLOSE(10)
      pchk=0
      pi=3.14
	fc='(12x,I4,16x,2I8,4F8.2)' !Format Palisades with isotopes & Td
	jf=0
 91   OPEN(15,STATUS='OLD',FILE=clfile,ERR=25)
	jf=jf+1
      READ(15,30,ERR=26)lat,alt
 30   FORMAT(/////,11X,F6.2,10X,I6,/)
      DO  i=1,365
          READ(15,fc,ERR=26)Chk,TmaxF(i),TminF(i),Prec(i),DewPt(i),
     +       dDprec(i),d18Oprec(i)
	    IF (Chk.NE.0.AND.Pchk-Chk.GT.-2.OR.Pchk-Chk.LT.31)THEN
	      Pchk=Chk
		  IF (d18Oprec(i).GT.998.0) THEN
			d18Oprec(i)=(isoO(11)*((TmaxF(i)+Tmin(i))/2))+isoO(12)+
     +		isoO(13)
c	isoO(13)=-3.28 ppmil is the altitude effect from UofA to Palisades (1640m alt dif)
		  ENDIF
		ELSE
	      GO TO 28
		ENDIF
		IF (dDprec(i).GT.998.0) THEN
			dDprec(i)=((isoH(12)*d18Oprec(i))+isoH(13))
		ENDIF
		d18Ovap(i)=(isoO(14)*d18Oprec(i))+isoO(15)
		dDvap(i)=((isoH(12)*d18Ovap(i))+isoH(13))
		Tmax(i)=(FLOAT(TmaxF(i))-32.)*5.0/9.0 ! Converts degF to degC
		Tmin(i)=(FLOAT(TminF(i))-32.)*5.0/9.0 ! Converts degF to degC
		Prec(i)=(Prec(i)*25.4) ! Converts inches to mm*10
		IF (DewPt(i).EQ.999.0) DewPt(i)=(0.7091*Tmin(i))-0.9384
c ****************************************************************
      END DO
      CLOSE(15)
	IF(lat.LT.0)then
		hemisphere='s'
	ELSE
		hemisphere='n'
	ENDIF
      lat=pi/180.0*lat
C  *************************************************************************     
CC   Interpolation of missing temperature data
C  *************************************************************************     
      CALL INTPOL(Tmax,M11,M12)
      CALL INTPOL(Tmin,M21,M22)
      DO i=1,365
            IF(Tmax(i).LT.Tmin(i))Tmin(i)=Tmax(i)
      END DO
      M1=MAX(M11,M21)
      M2=MIN(M12,M22)
      M=M2-M1+1
      NU=M1-1
      dif=cons(19)*cons(20)            ! Lapse rate temp adjustment
      DO i=M1,M2
         Temp(i)=(Tmax(i)+Tmin(i))/2   ! T avarage
         IF(Prec(i).LT.-9000)Prec(i)=0.0
		IF (DewPt(i).GE.0.0) THEN
			e(i)=EXP(1.80985+((17.27*DewPt(i))/(DewPt(i)+237.3)))
		ELSE
			e(i)=EXP(1.80985+((21.87*DewPt(i))/(DewPt(i)+265.5)))
		ENDIF
		IF (Temp(i).GE.0.0) THEN
			es(i)=EXP(1.80985+((17.27*Temp(i))/(Temp(i)+237.3)))
		ELSE
			es(i)=EXP(1.80985+((21.87*Temp(i))/(Temp(i)+265.5)))
		ENDIF
	    hum=e(i)/es(i)                              ! Humidity
C  *************************************************************************     
CC  Water Deficit= density of air * 0.622 *(saturation water vapor pressure -
CC    water-vapor pressure) /atm. pressure
C  *************************************************************************
	   Pr=cons(7)  
         wddef(i)=cons(3)*0.622*(es(i)-e(i))/Pr
      END DO

c     NICOLOV NT (1992) - daily irradiation & day length
c     Avarage radiation in : J/m^2 /s
c     day length in: h
      Sc=cons(1)                !  solar constant
      pi=3.14
      DO j=1,365
            sind=0.39785*SIN(4.868961+0.017203*j+0.033446*
     +           SIN(6.224111+0.017202*j))
CC sin(d) - d is the solar declination
            cosd=SQRT(1-sind**2)
            coshs=-SIN(lat)*sind/(COS(lat)*cosd)
            Rad(j)=0.0846/pi*Sc*(1+0.033*COS(2.0*pi/365.0*j))*
     +           (COS(lat)*cosd*SQRT(1-coshs**2)+ACOS(coshs)*
     +           SIN(lat)*sind)
CC hs -  is the daylenth (rad)
		hs=24.0/pi*ACOS(coshs)
		Dlen(j)=hs
      END DO
CC from Nicolov, 1992
	betta=.715-.3183*(1-1.3614*COS(lat))
c   the correction on cloudiness
      DO j=1,365
            x=Tmin(j)
            IF(j.LT.365)x=Tmin(j+1)
            deltat=Tmax(j)-(Tmin(j)+x)/2
            IF(deltat.LE.0.0)THEN
                  x=1
            ELSE
                  x=deltat**2.4
            END IF
            ti=cons(6)*(1.0-EXP(-cons(9)*x))
            Rad(j)=Rad(j)*ti*betta
      END DO
      CALL TRANS01(wddef,trp,Rmin)  !Calculates transp as water deficit/Rmin
      iin=INDEX(clfile,'.')-1
	IF(hemisphere.EQ.'s')THEN
CC preparation for south hemisphere
	IF(jf.EQ.1)THEN                  ! read next year
	   READ(clfile(iin-3:iin),'(I4)')ii
	   ii=ii+1
	   WRITE(clfile(iin-3:iin),'(I4)')ii
	   DO i=183,365
		Temp1(i-182)=Temp(i)
		Prec1(i-182)=Prec(i)
		Rad1(i-182)=Rad(i)
		Dlen1(i-182)=Dlen(i)
		trp1(i-182)=trp(i)
	   END DO
	GOTO 91
	ENDIF
	DO i=1,182
		Temp1(i+183)=Temp(i)
		Prec1(i+183)=Prec(i)
		Rad1(i+183)=Rad(i)
		Dlen1(i+183)=Dlen(i)
		trp1(i+183)=trp(i)
	END DO
	DO i=1,365
		Temp(i)=Temp1(i)
		Prec(i)=Prec1(i)
		Rad(i)=Rad1(i)
		Dlen(i)=Dlen1(i)
		trp(i)=trp1(i)
	END DO
	ENDIF
      IF(op(12).EQ.3.AND.op(13).NE.1)THEN
       OPEN(16,File='mc'//clfile(iin-3:iin)//'.dat')
       WRITE(16,'(A4,9A12)')'day','Tmin','Temp','Tmax','DewPt','Prec',
     +                  'Rad','Dlen','trp','e-es'
       DO i=M1,M2
         WRITE(16,'(I4,9F12.4)')i,Tmin(i),Temp(i),Tmax(i),DewPt(i),
     +                       Prec(i),Rad(i),Dlen(i),trp(i),e(i)-es(i)
       END DO
       CLOSE(16)
      ENDIF
      RETURN
 10      WRITE(*,*)' No file MCconst ????'
	   GOTO 27
 25      WRITE(*,'('' ERROR in statment OPEN-'',A)')clfile
         GOTO 27
 26      WRITE(*,'('' ERROR in file format-'',A)')clfile
         GOTO 27
 28      WRITE(*,'('' ERROR in input data-'',A,'' Day-'',i3)')clfile,i
 27      PAUSE
      RETURN
      END

      SUBROUTINE INTPOL(x,M1,M2)
C  *************************************************************************     
CC   Interpolation of missing temperature data 
C  *************************************************************************     
      REAL x(366)
      M1=1
      M2=365
      i=1
      DO WHILE(x(i).LT.-900) !Start at Beginning of season
         i=i+1
      END DO
      M1=i  !Beginning of 1st group of valid values
 20   i=i+1
      IF(x(i).LT.-900)THEN !This value is missing
        j=i ! J is start of next missing data
        DO WHILE(x(j).LT.-900.AND.j.NE.365)
          j=j+1
        END DO
        IF(j.LT.365)THEN !J-1 is number missing not at end of year
c       J is beginning of valid data
          f=(x(j)-x(i-1))/(j-i) !f is average difference per year
          DO k=i,j-1
            x(k)=x(k-1)+f ! Estimate
          END DO
          i=j-1
          GOTO 20
        ELSE IF(x(j).GT.-900)THEN ! End of year
C  *************************************************************************     
cc  Estimate at end of year
C  *************************************************************************     
          f=(x(j)-x(i-1))/(j-i) 
          DO k=i,j-1
            x(k)=x(k-1)+f
          END DO
          i=j
          M2=i
          GOTO 51
        ELSE IF(j-i.LT.11)THEN
          DO k=i,j
            x(k)=x(k-1)
          END DO
          i=j
          M2=i
          GOTO 51 !Return
        ELSE
          M2=i-1
          GOTO 51 ! Return
        END IF
      ELSE ! x greater than -900
         IF(i.EQ.365)THEN
            M2=i
            GOTO 51 ! Return
         END IF
         GOTO 20 ! Continue looking for missing data
      END IF
 51   RETURN
      END

C   
      SUBROUTINE beggr(temp,sm,p,j,t)
CC  The determination of the time when seasonal growth is began
CC  temp() - temperature
CC  sm(i)  - resistance (Was soil Moisture)
CC  j      - current day
CC  t      - julian day after when growth begins
      REAL     temp(366), p(60), sm(366)
      INTEGER  t
      iperiod=p(31)
      s=0.0
      ii=j-iperiod
      sum=0.0
      imo=1
      DO i=1,iperiod
         s=s+temp(ii)
         sum=sum+sm(ii)!resistance
         ii=ii+1
      END DO
c      sum=sum/iperiod ! Calculate mean
c      IF(sum.gt.p(30).OR.s.LT.p(32))go to 10 !Changed 10/11/99 to below
	IF(s.GE.p(32))THEN
c        IF(sum.LT.p(30))THEN 
          t=j+1 ! Start growth tomorrow & Return
c	  END IF 
      END IF  !Don't start growth & Return
10    RETURN
      END

      SUBROUTINE FILTER(F,N,TFL)
C       THIS SUBROUTINE PERFORMS EITHER HIGH- OR LOW-PASS FILTERING
C       OF DATA, USING A 7-WEIGHT FILTER FUNCTION.
C       INPUT:  F IS THE INPUT DATA VECTOR (MAX 500 DATA POINTS) TO
C               BE FILTERED.  DESTROYED DURING COMPUTATION.
C               N IS THE LENGTH OF F.
C               TFL=A FOR 7-YEAR AVEREAGE; =L FOR LOW-PASS HALF FILTER;
C               V FOR LOW LOW-PASS HALF FILTER.
C       OUTPUT: FILTERED VALUES ARE RETURNED IN VECTOR F.

      CHARACTER   TFL*1
      REAL        F(N)
      DIMENSION   X(-11:377),WT(12),WTL(7),WTH(7),WTLL(12)
      DATA        WTL /.3680,.3153,.1971,.0876,.0263,.0049,.0005/
      DATA        WTH /.1429,.1429,.1429,.1429,.1429,.1429,.1429/
      DATA        WTLL/.1538,.1502,.1429,.1319,.1172,.0989,.0769,
     +                 .0549,.0363,.0220,.0110,.0037/

      DO I=1,N
	 X(I)=F(I)
      END DO
      IF(TFL.EQ.'V'.OR.TFL.EQ.'v') THEN
	 DO K=1,12
	    WT(K)=WTLL(K)
	  END DO
	 LIMIT = 11
      ELSEIF(TFL.EQ.'L'.OR.TFL.EQ.'l')THEN
	 LIMIT = 6
	 DO K=1,12
	     WT(K)=WTL(K)
	  END DO
      ELSE
	  LIMIT=6
	 DO K=1,12
	    WT(K)=WTH(K)
	  END DO
      ENDIF
C       DATA VALUES FOR YEARS 1 THROUGH LIMIT ARE SUMMED AND THE MEAN
C       IS CALCULATED.  11/88
      DO K=1,LIMIT+1
	 SUM=SUM+X(K)
      END DO
      XMN=SUM/(LIMIT+1)
C       THE MEAN IS STORED IN LOCATIONS -LIMIT TO 0 OF X ARRAY
C       (ONLY LIMIT -1 LOCATIONS ARE USED BECAUSE K=1 IS CENTRAL VALUE
C       OF THE COMPLETE FILTER.  4/78
      DO K=-LIMIT,0
	 X(K)=XMN
      END DO
C       THE MEAN FOR N-6 TO N YEARS IS CALCULATED AS ABOVE.  4/78
      SUM=0.0
      DO K=N-LIMIT,N
	 SUM=SUM+X(K)
      END DO
      XMN=SUM/(LIMIT+1)
C     MEAN IS WRITTEN IN LOCATIONS, N+1 TO N+LIMIT.  4/78
      DO K=N+1,N+LIMIT
	 X(K)=XMN
      END DO
      DO I=1,N
	 F(I)=0.0
C       VALUES ARE CALCULATED FOR EACH YEAR USING THE WEIGHTS.  4/78
	 DO J=1,LIMIT+1
	    L=I-J+1
C       CHANGED TO FILTER ONLY LEFT OF CENTRAL VALUE X(I-LIMIT+1) TO X(I)
	    F(I)=F(I)+WT(J)*X(L)
	  END DO
      END DO
      RETURN
      END
