C     Subroutine TRGInput Version 7.1  2/2/2001
C
      SUBROUTINE TRGINPUT(Tmax,Prec,p,prp,zini,b,den,op,begyear,ig,
     *endyear,jj,trwidth,hold,age,agemax,depth,Sarea,inputc,rwinput,
     *nMleaf,clfile,AveTmx,AvePin,RealW,ierror)
C       jj (1 to m) counts number of additional years analyzed
      REAL p(60),prp(3),zini(100),b(100),den(5),Tmax(366),Prec(366),
     *hold(20),K,Needindx,nMleaf,AveTmx(24),AvePin(24), RealW(100)
      INTEGER op(40),begyear, endyear, age, agemax
	CHARACTER clfile*8
c      bh=1.3      !Brest height in meters
      ierror=0
      pi=3.14     !pi value assigned
      IF(op(12).EQ.2.AND.op(13).NE.1)THEN
 	  IF(inputc.EQ.0)THEN
	    OPEN(17,FILE=clfile(1:4)//clfile(7:8)//'IO.DAT') 
	    WRITE(17,'('' DAY   1. INITIAL TRGINPUT DATA AND OUTPUT.''/)')
	  ELSE
          OPEN(17,FILE=clfile(1:4)//clfile(7:8)//'I.DAT')
	    WRITE(17,'('' DAY '',F4.0,'' TRGINPUT DATA AND OUTPUT.'')')
     *      p(51)
	  ENDIF
      ENDIF	
	IF(inputc.EQ.0)THEN  !Reads at beginning of year for first year
        radius=zini(32) ! Radius (m) from pith to first measured year
	  age=zini(31)-zini(30)! Age just before measurements available
	  IF(begyear.LT.zini(31))THEN 
	    PAUSE ' Starting years incompatable in .INF and .IO files'
          STOP
	  ELSE IF(begyear.GT.zini(31))THEN  !
c       begyear is later than first measurement
          AgeMax= endyear-begyear+1
          DO i=1,begyear-zini(31)  !Read to year before begyear     
	      Read(40,'(I5,6X,F9.1)')IYEAR,WIDTHmu ! Width in microns
	         radius=radius+widthmu*1E-6 ! Width in meters
	         age=age+1 ! Age to year before current year
            IF(op(12).eq.2)Write(17,'('' Year:'',I4,'' Width mcm:'',
     *         F8.0,'' Total m:'',F8.6,'' Age:'',I3)')iyear,widthmu,
     *         radius,age 
          END DO
C         Save radius (R)for next years calculation sav(1)
     	  END IF
        hold(1)=Radius !Current stem radius       
	ELSE 
C      inputc is greater than 0, not the first time through
C     R=radius of stem bh, RWINPUT EST from dendrograph, 
C       TRWIDTH prev Est RW (will be 0 until year 2)for op(20)=0
        age=age+1
        IF(OP(20).eq.0)THEN
          radius=hold(1)+trwidth*1E-6+rwinput*1E-6
C         Save radius (R)for next years calculation sav(1)
          hold(1)=Radius-rwinput*1E-6 !Current stem radius wo incomplete ring      
        ELSE
	    Read(40,'(I5,6X,F9.1)')IYEAR,WIDTHmu ! Width in microns
	    BACKSPACE 40
          IF(IYEAR.EQ.BEGYEAR+JJ-1)THEN
	      IF(JJ.EQ.1)THEN
	        radius= hold(1)+WIDTHmu*1E-6
	        trwidth=0.
	        rwinput=WIDTHmu
	      ELSE
		    radius=hold(1)+WIDTHmu*1E-6
	        trwidth=RealW(JJ-1)
	        rwinput=WIDTHmu
	      ENDIF
	      hold(1)=radius
	    ELSE
            WRITE(*,'('' Year ='',I5,'' Actual Ring Width ='',F8.2)')
     .        IYEAR, WIDTHmu 
	      ierror=1
	      RETURN
	    ENDIF
        ENDIF
	END IF
C    Hold 1=radius at beginning of previous year 
C    Hold 4=Sapwood Mass, 5=Fine Root Mass, 6=Height, 7=Not used
C    Hold 8=V (Sapwood Volume), 9= K,  10=Volume of living stem cells.
C    Hold 11-20 Mass of 1 to 10=year old needles
C      Estimate the needle growth index
	Needindx =1.
      IF(JJ.GT.1)THEN
	  Needindx=0.0
	  DO I=1,24
	    Needindx=Needindx + zini(50+I)*AveTmx(I)
	    Needindx=Needindx + zini(74+I)*AvePin(I)
	  END DO
	Needindx=Needindx+zini(99)
      ENDIF
C Total Stem area at bh is pi*radius**2
	Stemar=pi*(radius)**2 !m^2
C Soil area and depth
	depth=p(14)
	sarea=p(15)
	If(zini(37).GT.0)depth=(age/(age+zini(37)))*p(14) !Soil depth
C Height= coeff 2 *age**2+ coeff 1 *age ! Height in m 
      height=zini(18)*age**2+zini(19)*age ! Height in m
      HeightMax=zini(18)*agemax**2+zini(19)*agemax !Max heght in m
	HOLD(6)=height
C Surface Area (S=2*pi*radius*(height+depth)) + depth of large root vol
      S=2*pi*radius*(height+depth)
C Heartwood Radius in mm and m and Heartwood Area
      HWRadmm=(zini(20)*radius*1000)+zini(21)
	IF(HWRadmm.LT.0.0)HWRadmm=0.0
      HWRad=HWRadmm*0.001
C Heartwood area m
      Heartar=pi*HWRad**2.0
C 	Saparea=Stemarm-Heartar
	saparea=stemar-heartar !m^2
	SWAcm=saparea*10000.0
C  Sapwood Radius Delta
      Delta=Radius-HWRad
C  Crown Mass (kg) as function of Sapwood area (cm)and Crown height 
C      CrownMa=zini(25)*(SWAcm)**(zini(26))*zini(28)*height**(zini(27))
      CrownMa=zini(25)*SWAcm**(zini(26))*zini(28)*height**(zini(27))
C  Crown Area (m)  as function of Sapwood area (m)
	CrownAr=CrownMa*p(3)
C Soil surface area (sarea=zini(29)*CrownAr
C     IF(zini(29).GT.0)sarea=(age/(age+zini(36)))*p(15) !Soil area
      IF(zini(29).GT.0)sarea=zini(29)*CrownAr
      IF(sarea.GT.p(15))sarea=p(15)
C Phloem area is (pi*(radius+zini(13))**2)-Stemar
      Phlar=(pi*(radius+zini(13))**2)-Stemar
C Circumference of cambium = radius*2*pi
      camcir=radius*2*pi
C Number of xylem initials (N) at brest heighth(1-fract % of Rays) X
C             camcir/tangential radius in m
      camcell=camcir/(b(3)*0.000001)
	tracini=(1-zini(24))*camcell
C  Cambial area is cambial circumference X Stem height
      Camar=camcir*(height*depth)
      IF(prp(2).EQ.0)prp(2)=camar
C  Stem volume including branches and coarse roots is calculated as a 
C    cylinder with diameter at brest height and the height of tree + 
C    root depth.
C    More accurate equations can be used in the future if there are 
C      data for them.
      CoRtVo=Stemar*depth
	CoRtMass=CoRtVo*den(3)
      StemVol=Stemar*height+CoRtVo !Includes coarse roots
	StemMass=StemVol*den(3)      !Includes coarse roots
C  Sapwood Volume (V=pi*delta(1-delta/2*R)*S)
C      sapvo=saparea*height
	K=delta*(1-delta/2/Radius)
	V=K*S  ! Sapwood Volume
	N=2*pi*Radius
C  Sapwood mass is Sapwood Volume X Density of Wood
      sapmass=V*den(3)
	HOLD(4)=sapmass
C  Phlowm volume is Phloem area X Stem height
      Phlovo=Phlar*(height+depth)
C  Phloem mass is Phloem volume X Density (balsa wood)
      Phloma=Phlovo*den(2)
      IF(inputc.EQ.0)THEN
        DO i=1,p(1)
          HOLD(i+10)=CrownMa/p(1) !Mass of needles for each year
        ENDDO    
	ELSE
        potcrown=0
	  DO i=p(1),2,-1
          HOLD(i+10)=HOLD(i+9)! Move masses to next years needles
	    potcrown=potcrown+HOLD(i+10)
        ENDDO
        potcrown=CrownMa-potcrown ! Mass of one-year needles uncorrected
C          In first year Needindx=1.0
	  HOLD(11)=potcrown*Needindx !!Mass of new one-year old needles
	END IF
	nMleaf=0.
      DO i=1,p(1)
	  nMleaf=hold(i+10)+nMleaf ! new mass of leaves 
	ENDDO

c *****************************************************************
C  Volume of Cambial Initials for only Tracheids is cambial area X 
C    fractional percent of cambium that is not rays
C  Caminvo=Camar*(1-zini(24))*0.000005
C  Ray volume in sapwood is fractional percent of rays X Sapwood vol
      Rayvo=V*Zini(24)
C  Mass of living stem is sapmass
C  Fine Root mass compared to All other masses
      Rootma=zini(39)*(CROWNMA+SapMass+Phloma) !Living root mass
C  Fine root (living) mass of fine roots 
      HOLD(5)=Rootma          !Living Fine Root Mass
	HOLD(8)=V  !Sapwood Volume
	HOLD(9)=K
	HOLD(10)=Rayvo+Phlovo+(Camar*Zini(38))
      IF(op(12).EQ.2.AND.op(13).NE.1)THEN
        WRITE(17,'(/'' Year:                '',I5/
     .'' Tree Age:            '',I5/
     .'' Section Radius:      '',F10.5/
     .'' Stem Area:           '',F10.5/
     .'' Heartwood Area:      '',F10.5/
     .'' Height:              '',F10.5/
     .'' Phloem Area:         '',F10.5/
     .'' Sapwood Area m:      '',F10.5/
     .'' Sapwood Area cm:     '',F10.5/
     .'' Crown Area:          '',F10.5/
     .'' Crown Mass:          '',F10.5/
     .'' Pot. Yrs Cr Mass:    '',F10.5/
     .'' Cambial Area prp(2): '',F10.5/
     .'' Trach. Initials dbh: '',F10.0/
     .'' Ray Volume:          '',F10.5/
     .'' Phloem Volume:       '',F10.5/
     .'' Phloem Mass:         '',F10.5/
     .'' Live Coarse Rt. Mass:'',F10.5/
     .'' Live Fine Root Mass: '',F10.5/
     .'' Soil Surface - m:    '',F10.5/
     .'' Soil Depth - m:      '',F10.5/
     .'' Stem Mass wo bark:   '',F10.5/
     .'' Sapwood Vol-tree (V):'',F10.5/
     .'' Sapwood Mass-tree:   '',F10.5/
     .'' K:                   '',F10.5/
     .'' No. Cam. Init. - dbh:'',F10.1/
     .'' Previous Ring Width: '',F10.2/
     .'' Est/Act Ring Width:  '',F10.2/
     .'' Needle Index:        '',F10.5)')ig,AGE,
     .RADIUS,STEMAR,HEARTAR,HEIGHT,PHLAR,SAPAREA,SWAcm,CROWNAR,
     .CROWNMA,potcrown,CAMAR,TRACINI,
     .RAYVO,PHLOVO,PHLOMA,CoRtMass,HOLD(5),Sarea,depth,
     .PHLOMA+SAPMASS,V,SAPMASS,K,CAMCELL,trwidth,rwinput,Needindx
      IF(inputc.EQ.0)WRITE(17,'('' ZINI('',I3,''):'',F13.5)')
     .  (I,ZINI(I),I=1,100)
      WRITE(17,'('' HOLD('',I3,''):'',F13.5)')(I,HOLD(I),I=1,20)
        CLOSE(17)
      ENDIF
      inputc=inputc+1
      RETURN
      END

      SUBROUTINE AVECLDAT(Prec,Tmax,AveTmx,AvePin,Clfile,op,jj,ig)
      REAL Prec(366),Tmax(366),AveTmx(24),AvePin(24)
	INTEGER month(12),op(40)
	CHARACTER clfile*8,monthc*1(12)
      DATA monthc /'J','F','M','A','M','J','J','A','S','O','N','D' /
      DATA month /31,59,90,120,151,181,212,243,273,304,334,365 /
C      DATA monthc /'J','A','S','O','N','D','J','F','M','A','M','J' /
      IStart=1
      Do I=1,12
        AveTmx(I)=AveTmx(I+12) !Move Ave to Ave Previous Year
        AvePin(I)=AvePin(I+12)
        AveTmx(I+12)=0.
	  AvePin(I+12)=0.
        n=0
	  Do J=IStart,month(I)
          AveTmx(I+12)=AveTmx(I+12)+Tmax(J) ! Sums daily temp data
          AvePin(I+12)=AvePin(I+12)+Prec(j) ! Sums daily precip data
	    n=n+1
        End Do
	  AveTmx(I+12)=(AveTmx(I+12)*1.8/n)+32. ! Averages & Converts C to F
	  AvePin(I+12)=AvePin(I+12)/25.4    ! Converts total in mm to inches
	  IStart=month(I)+1
      End Do
c	IF(op(12).EQ.2.AND.op(13).NE.1)THEN
c        Open(20,FILE=clfile(1:4)//clfile(7:8)//'AV.DAT')
c        WRITE(56,'(I6,12F6.2)')ig+JJ-1,(AveTmx(J),J=13,24)
c        WRITE(57,'(I6,12F6.2)')ig+JJ-1,(AvePin(J),J=13,24)
c	    WRITE(20,'(I3,'' Previous T '',A1,1x,F8.2,'' P '',F8.2)')I,
c     .         monthc(I),AveTmx(I),AvePin(I)
c        End Do
c        Do I=13,24
c	    WRITE(20,'(I3,'' Current  T '',A1,1x,F8.2,'' P '',F8.2)')I,
c     .         monthc(I-12),AveTmx(I),AvePin(I)
c        End Do
c	END IF
	Close(20)
	RETURN
	END


      SUBROUTINE CLIMIT(MMCNST,MASS,CNST,SUBSTANCE,LIMIT)
C MM Constant function with a constant rather than o value (mM CO2/kg/day)
      REAL MMCNST, MASS, CNST, SUBSTANCE, LIMIT 
! limiting by sugar supply
         fmc=MMCNST*MASS !M M Const (mM) converted to total substance
	   fmcmin=CNST*MASS ! Constant Scaled to mass
c	   IF(fmc.LE.2*fmcmin)fmcmin=0.499*fmc 
! If total MM sugar LE 2 x root mass, Scaled root mass = .499 total sugar
         available_sugar=SUBSTANCE
c         LIMIT=(available_sugar-fmcmin)/
c     +        (available_sugar+fmc+2*fmcmin)
         LIMIT=(available_sugar-fmcmin)/
     +        (available_sugar-fmcmin+fmc)
         IF(LIMIT.LT.0.0)LIMIT=0.0
	   IF(LIMIT.GT.1.0)LIMIT=1.0
	RETURN
	END
      
	SUBROUTINE VALUEST(i,hold,p,fratio,mleaf,nmleaf,larea,mstem,mroot
     +  ,mfroot,svolume,form,volume,cratio,op)
	REAL p(60),fratio(5),hold(20),mleaf,nmleaf,larea,mstem,mroot
	REAL mfroot,form,volume,cratio
	INTEGER op(40)
	IF(i+1.EQ.P(51))THEN
        cratio=1.0/p(52)
	  fratio(1)=mLeaf
	  fratio(2)=Mstem
	  fratio(3)=Mroot
	  fratio(4)=form
	  fratio(5)=volume
        IF(op(12).EQ.2.AND.op(13).NE.1)THEN
	    WRITE(75,'('' DAY   mLeaf    Mstem     Mroot      form     vol
     +ume'')')
	    WRITE(75,'(I4,5F10.5)')i,mLeaf,Mstem,Mroot,form,volume
	  ENDIF
	  RETURN
      ELSEIF(i.EQ.P(51))THEN
	  fratio(1)=(nMleaf-fratio(1))*cratio
	  fratio(2)=(hold(4)-fratio(2))*cratio
	  fratio(3)=(hold(5)-fratio(3))*cratio
	  fratio(4)=(hold(9)-fratio(4))*cratio
	  fratio(5)=(hold(10)-fratio(5))*cratio
        IF(op(12).EQ.2.AND.op(13).NE.1)THEN
	    WRITE(75,'(I4,'' nMass '',F10.5,'' Fratio '',5(i4,F15.10))')i,
     + nmLeaf,(j,fratio(j),j=1,5)
c         DO J=1,5
c	    IF(fratio(j).LT.0)fratio(j)=0.
c	   ENDDO
	  ENDIF
      ENDIF 
      mLeaf=mLeaf+fratio(1)
	Larea=Mleaf*p(3)      
      Mstem=Mstem+fratio(2)  ! Living Mass of stem
      Mroot=Mroot+fratio(3)  ! Living Mass of all roots from Input
	MFroot=Mroot
	form=form+fratio(4)
	volume=volume+fratio(5)	  
        IF(op(12).EQ.2.AND.op(13).NE.1)THEN
	    WRITE(75,'(I4,5F10.5)')i,mLeaf,Mstem,Mroot,form,volume
        endif
	RETURN
	END