C Version 7.0  3/31/2000
C      
      SUBROUTINE camb70(ii,op,ch,b,num,state,Tem,Rg,Sp,SL,SS,SR,
     +		   d13Cps,d13CstL,d13CstS,d13CstR,d13CC,
     +		   dDps,dDstL,dDstS,dDstR,dDC,
     +		   d18Ops,d18OstL,d18OstS,d18OstR,d18OC,Time,dlen,
     +		   Mleaf,volume,swvol,Mroot,form,Ct,Cte,Ctm,Gr,Correct,
     +           dorm,dist,b3,cellsize,
     +		   d13CstLAr,d13CstSAr,d13CstRAr,dDstLAr,dDstSAr,dDstRAr,
     +		   d18OstLAr,d18OstSAr,d18OstRAr,SuLAr,SuSAr,SuRAr)
       
c Subroutine v 7.0 02.02.2000	

cc ch(,)       -
C   1 - the age of the cell 
C   2 - the time spend in enlargement stage
C   3 - the potential cell size
C   4 - the time spend in maturation stage
C   5 - the time switch to death stage
C   6 - the initial cell size mic.m
C   7 - the cell density (wall density/cell area) kg/m3
C   8 - the size
C   9 - the wall thickness
C  10 - d13C 
C  11 - dD
C  12 - d18O   
cc b           - cambial parameters
cc num()       - number cells in the ring (1), cambium (2),
cc               enlargement (3),muturation (4)
cc state()     - state of cell division(c), enlargement (e), maturation (m),
cc                fully mature and dead (d)          
cc Tem         - temperature
cc Rg          - resistence
cc Sp          - current avilable photosynthetic sugar
cc SL,SS,SR    - sucrose in the foliage, stem and root
cc dSp         - d13C in current photosynthetic sugar
cc dSL,dSS,dSR - d13C in same compartments
cc Time        - current time (day of year)
cc dlen        - daylength
cc Mleaf       - mass of foliage   (kg)
cc swvol       - volume of sapwood (m^3)
cc Mroot       - mass of root      (kg)  
cc form        - coefficient in eq. V=kS, S - sapwood area.
cc Ct,Cte,Ctm  - crown control, output are Fc,Fe,Fm
cc               environment control of growth
cc Gr()        - growth rate of cambium, enlagement
cc               and maturation cells (mMco2)
cc dist        - size of living cells in ring
cc cdist       - distance of cell j from initial cell
cc dorm        - check on dist, if previous = current then dorm=0 
      REAL rate_division
      REAL rate_min
      REAL rate_e
	REAL rate_m
      REAL ch(12,1000)
	REAL Correct(3,200)
      REAL b(100),Gr(12)
      REAL Tem,Rg,Sp,SL,SS,SR
	REAL d13Cps,d13CstL,d13CstS,d13CstR,d13CC
	REAL dDps,dDstL,dDstS,dDstR,dDC
	REAL d18Ops,d18OstL,d18OstS,d18OstR,d18OC
      REAL dlen,volume,swvol,form,Ct,Ctm,dist,dorm
	REAL AsTc,AsTe,AsTm,Mleaf,Mroot,mass,dmass,wallsum
	REAL available_sugar
	REAL d13CstLAr(366),d13CstSAr(366),d13CstRAr(366)
	REAL dDstLAr(366),dDstSAr(366),dDstRAr(366)
	REAL d18OstLAr(366),d18OstSAr(366),d18OstRAr(366)
	REAL SuLAr(366),SuSAr(366),SuRAr(366)
      INTEGER num(4)               
      INTEGER op(40) 
      INTEGER Time,i,ii
      CHARACTER state*1(1000) 
      CHARACTER w*1
      b3=b(3)
!  the size of living zone
      cstop=dist-dorm
	wallsum=0.
      dist=0 !Sum of widths for all living cells
c    HCF Added to use total ring width if b(100)=1
      DO i=1,num(1) !Calculates distance from cell widths in ring
         w=state(i)
         IF(w.EQ.'c'.OR.w.EQ.'e'.OR.w.EQ.'m')dist=dist+ch(8,i)
         IF(w.EQ.'c'.OR.w.EQ.'e'.OR.w.EQ.'m')wallsum=wallsum+ch(9,i)
         IF(b(100).EQ.1.)THEN
           IF(w.EQ.'d')dist=dist+ch(8,i)
           IF(w.EQ.'d')wallsum=wallsum+ch(9,i)
         END IF
      END DO
	dorm=dist+wallsum
C  ******************************************
CC  BEGINNING OF CAMBIUM CONTROL CALCULATIONS
C  ******************************************
!   Limiting conditions: limiting for temperature
!   for growth of cambium, enlargement and maturation stages 
!   Limiting conditions of temperature
      AsTc=TFUNC(Tem,b(37),b(38),b(39),b(40))    
      AsTe=TFUNC(Tem,b(57),b(58),b(59),b(60))    
      AsTm=TFUNC(Tem,b(77),b(78),b(79),b(80))    
      Gr(6)=AsTc
      Gr(9)=AsTe
      Gr(12)=AsTm    
!   Limiting conditions: limiting for water stress
      AsWc=MIN(1.0,(b(35)-Rg)/(b(35)-b(36)))      
      IF(AsWc.LT.0)Aswc=0
      AsWe=MIN(1.0,(b(55)-Rg)/(b(55)-b(56)))      
      IF(AsWe.LT.0)Aswe=0
      AsWm=MIN(1.0,(b(75)-Rg)/(b(75)-b(76)))      
      IF(AsWm.LT.0)AsWm=0
c	Gr(5)=AsWc
	Gr(5)=(1.0/b(41)+(1.0-1.0/b(41))*AsWc)
c	Gr(8)=AsWe
	Gr(8)=(1.0/b(49)+(1.0-1.0/b(49))*AsWe)
c	Gr(11)=AsWm
	Gr(11)=(1.0/b(69)+(1.0-1.0/b(69))*AsWm)
C  ******************************************
C  calculating some values needed below
C  ******************************************    
      v0=b(23)      !Growth rate during s, G2, and M phases 
      vs=b(21)*b(22)! min when cambium cells become dormant
      t0=1.0        ! the time-step         
      coef=45.617*swvol/(form*b(3))
C  ******************************************    
C   Initial conditions
C  ******************************************    
      ndiv=0        !  number of divisions per day
      xc=0          !  sum growth rate per cell division zone
      xe=0          !  sum growth rate per enlargement zone
      xm=0          !  sum growth rate per maturation zone
      j=1                       ! position of cell
C ---------------------------------------------------------------------
C  Loop of position from label 120 to 150
C ---------------------------------------------------------------------
      IF(op(12).EQ.2.AND.op(13).NE.1.AND.cstop.NE.0)WRITE(45,'(
     .'' Day Begin: '',I4,
     .'' Ct'',F5.2,'' Cte'',F5.2,'' Ctm'',F5.2,'' Day Length'',f6.2,
     .'' Dorm '',f8.3)')time,Ct,Cte,Ctm,dlen,dorm
 120  available_sugar=SS+SP
!  Limitation due to available sucrose above a minimum concentration
c      AscC=available_sugar/(available_sugar+b(34))
c  Limitation with minimum added by HCF 9/19/00        
      Call CLIMIT(b(34),swvol,b(33),available_sugar,AscC)
      Call CLIMIT(b(54),swvol,b(53),available_sugar,AscE)
c      AscE=available_sugar/(available_sugar+b(54))        
      Call CLIMIT(b(74),swvol,b(73),available_sugar,AscM)
c      AscM=available_sugar/(available_sugar+b(74))
	Gr(4)=AscC
	Gr(7)=AscE
	Gr(10)=AscM
      w=state(j)                ! characteristics of each cell
      SELECT CASE(w)            
       CASE('c')
C  *****************************     
C  cambium cells
C  *****************************     
C         Gc=AsTC*AsWC*AscC !Limitation to cambium
          Gc=Gr(6)*Gr(5)*Gr(4)
         cdist=0.0 
!  the distance cell j from initial cell
      DO i=1,j
         cdist=cdist+ch(8,i) !distance of cell j from cambium initial
      END DO
         vmin=rate_min(b,cdist,Ct) !Min rate when transferred to enlargement
         v=rate_division(b,dist,cdist,Ct,Gc) !Growth rate in cambial cell
         IF(ch(8,j).LE.b(10))THEN 
! --------------------- cell in phase G1
           IF(j.EQ.1.AND.vmin.GT.v)v=vs -.001 !vs - min rate for dormancy
!  This keeps the initial cell from disappearing into enlarging zone
!          and reduces rate to below dormancy threshold.
C Hal added next line 9/18/00 so only Initial cell goes dormant with min Dlen
            IF(j.EQ.1.AND.dlen.LE.b(29))THEN
	        IF(op(12).EQ.2.AND.op(13).NE.1.AND.cstop.NE.0)WRITE(45,'(
     .        ''  Cell'',I3,'' Initial cell dormant. v & vs= '',2f6.3)')
     .        J,v,vs
		   GOTO 150 !To end of Case
	      END IF
C           IF(v.LT.vs.OR.dlen.LE.b(29))GOTO 150 !changed to next 9/18/00
           IF(v.LT.vs)THEN
	        IF(op(12).EQ.2.AND.op(13).NE.1.AND.cstop.NE.0)WRITE(45,'(
     .        ''  Cell'',I3,'' Dormant. v & vs= '',2f6.3)')J,v,vs
		   GOTO 150  !To End of Case Changed by Hal 9/18/00
! --------------------- condition for dormant HAL - CHECK THIS CAREFULLY
           END IF
           IF(v.LT.vmin.OR.dlen.LE.b(29))THEN         
! --------------------- switch cell to zone of enlargement
             state(j)='e'                 
             ch(2,j)=0.0     !Sets Time in enlargement (T enl) to zero
             ch(3,j)=cdist   !Distance from initial cell
             ch(6,j)=ch(8,j) !Size when entering enlargement zone (iSize)
	       ve=rate_e(b,ch(2,j),ch(6,j),potsize,Ct,Ge)
	        IF(op(12).EQ.2.AND.op(13).NE.1)WRITE(45,'(''  Cell''
     .       ,I3,'' Switch to Enl. v '',E8.3,'' vmin '',E8.3,'' ve'',
     .        f6.3,'' cdist'',f7.1,'' size'',f6.2)')J,v,vmin,ve,cdist,
     .        ch(8,j)
		    
           ELSE 
C --------------------- growth of cambial cell in G1
             mass=2.0*ch(9,j)*(ch(8,j)+b(3)-2.0*ch(9,j))*coef !mass of tree
	       area=mass/coef
             ch(8,j)=ch(8,j)+v*t0   !Accumulated size    
             xc=xc+ 2.0*v*t0*ch(9,j) !sum growth rate per cell division zone      
             dmass= 2.0*v*t0*ch(9,j)*coef/0.8 !change in mass of tree
		   ch(7,j)=mass/area ! density
		   CALL Alloc(ii,'stem',mass,dmass,Sp,SL,SS,SR,
     +			Mleaf/1000.0,volume,Mroot/1000.0,d13Cps,d13CstL,
     +			d13CstS,d13CstR,ch(10,j),ch(10,j),d13CC,dDps,
     +			dDstL,dDstS,dDstR,ch(11,j),ch(11,j),dDC,d18Ops,
     +			d18OstL,d18OstS,d18OstR,ch(12,j),ch(12,j),d18OC,
     +			d13CstLAr,d13CstSAr,d13CstRAr,dDstLAr,dDstSAr,dDstRAr,
     +			d18OstLAr,d18OstSAr,d18OstRAr,SuLAr,SuSAr,SuRAr)

	        IF(op(12).EQ.2.AND.op(13).NE.1.AND.cstop.NE.0)WRITE(45,'(
     .        ''  Cell'',I3,'' In division zone  v '',E8.3,'' vmin '',
     .        E8.3,'' size'',f6.2,'' Live or Total Ring'',f7.1)')
     .        J,v,vmin,ch(8,j),dist
           ENDIF
           GOTO 150                           ! next cell
         ELSEIF(ch(8,j).LE.b(13))THEN  
C ---------------------- growth of cambial cell in  S,G2 and M (see ! above)
           mass=2.0*ch(9,j)*(ch(8,j)+b(3)-2.0*ch(9,j))*coef
	     area=mass/coef
           ch(8,j)=ch(8,j)+v0*t0 !Size
           xc=xc+2.0*(1.0+b(3)/(b(13)-b(10)))*v0*t0*ch(9,j)  
           dmass=2.0*(1.0+b(3)/(b(13)-b(10)))*v0*t0*ch(9,j)*coef/0.8
	     ch(7,j)=mass/area ! density
		   CALL Alloc(ii,'stem',mass,dmass,Sp,SL,SS,SR,
     +			Mleaf/1000.0,volume,Mroot/1000.0,d13Cps,d13CstL,
     +			d13CstS,d13CstR,ch(10,j),ch(10,j),d13CC,dDps,
     +			dDstL,dDstS,dDstR,ch(11,j),ch(11,j),dDC,d18Ops,
     +			d18OstL,d18OstS,d18OstR,ch(12,j),ch(12,j),d18OC,
     +			d13CstLAr,d13CstSAr,d13CstRAr,dDstLAr,dDstSAr,dDstRAr,
     +			d18OstLAr,d18OstSAr,d18OstRAr,SuLAr,SuSAr,SuRAr)
c
	        IF(op(12).EQ.2.AND.op(13).NE.1)WRITE(45,'(''  Cell''
     .       ,I3,'' Now Dividing Cell v '',E8.3,'' vmin '',E8.3,
     .'' size'',f6.2,'' Live Ring'',f7.1)')J,v,vmin,ch(8,j),dist
           GOTO 150                           ! next cell
         ENDIF
C  *************************************************************************     
CC  Division of cambial cell in position j
C  *************************************************************************     
         ndiv=ndiv+1   !Number of division counter
c         IF(j.EQ.1)ch(1,j)=time  !Sets time of last initial division 
! The shift cells on one position 
         DO i=1000,j+2,-1  !Shifts state from j+1 to 1000        
            state(i)=state(i-1)
           DO i1=1,12
              ch(i1,i)=ch(i1,i-1) !Shifts ch(1-12) from j+1 to 1000
           END DO
         END DO
	DO i=1,num(1)+ndiv-1  !Adjust the Correct Array 
	    IF(Correct(2,i).GT.j) Correct(2,i)=Correct(2,i)+1
!          
      ENDDO
	Correct(1,num(1)+ndiv)=time !Time in days is recorded for each   
!     division, stored in position (ndiv) beyond the number in the ring
      Correct(2,num(1)+ndiv)=j+1  !Position j+1 is recorded for each
!     division, stored in position (ndiv) beyond the number in the ring
!  This is crazy but entered by Alex to correct code error of position
! first daughter cell - position j (same number as Mother cell)
         ch(8,j)=ch(8,j)/2.0       !  Half Size at cell division
	        IF(op(12).EQ.2.AND.op(13).NE.1)WRITE(45,'(''  Cell''
     .       ,I3,'' 1st Daughter cell v '',E8.3,'' vmin '',E8.3,
     .       '' size'',f6.2,'' Live or Total Ring'',f7.2)')J,v,vmin,
     .       ch(8,j),dist
! second daughter cell - position j+1
         j=j+1
         ch(8,j)=ch(8,j-1)      !Size   
         IF(j.EQ.2)ch(1,j)=time   
         IF(ch(1,j-1).NE.0)ch(1,j)=ch(1,j-1)
! first row set to time it was formed 
c         IF(j.LE.2) ch(1,j)=time   
         ch(9,j)=ch(9,j-1)  !Wall thickness
	   ch(10,j)=ch(10,j-1) !d13C         
	   ch(11,j)=ch(11,j-1) !dD        
	   ch(12,j)=ch(12,j-1) !d18O        
         state(j)='c'              ! state is still cambium
	        IF(op(12).EQ.2.AND.op(13).NE.1)WRITE(45,'(''  Cell''
     .       ,I3,'' 2nd Daughter cell v '',E8.3,'' vmin '',E8.3,
     .       '' size'',f6.2,'' Live or Total Ring'',f7.2)')J,v,vmin,
     .       ch(8,j),dist
        CASE('e')  
C ******************************
C  cell in enlargement stage 
C ****************************** 	                         
          potsize=b(2)-(b(2)-b(1))*exp(-b(44)*(ch(3,j)-b(45)))
          potsize=MAX(b(1),potsize)
          Ge=Gr(9)*Gr(8)*Gr(7)
	    ve=rate_e(b,ch(2,j),ch(6,j),potsize,Ct,Ge)
          ch(2,j)=ch(2,j)+t0 ! Pos
          IF(ch(8,j).GT.b(1).AND.ve.LT.b(42).OR.ch(8,j)+ve*t0.GT.b(2))
     +    THEN 
! --------------------- Switch to maturation stage           
            state(j)='m'    ! Assignes new values for maturation
            ch(4,j)=0.0     ! First day in maturation zone
              cellsize=ch(8,j)
	        IF(op(12).EQ.2.AND.op(13).NE.1)WRITE(45,'(''  Cell''
     .        ,I3,'' Switch to Wall Thickening ve'',f6.3,'' vemin'',f5.2
     .        ,'' vm'',f6.3,'' vmmin'',f6.3'' wall'',f5.2,'' size'',f6.2
     .        )')J,ve,b(42),vm,b(62),ch(9,j),ch(8,j)
          ELSE
C --------------------- Growth cell in enlagement stage
            mass=2.0*ch(9,j)*(ch(8,j)+b(3)-2.0*ch(9,j))*coef
		  area=mass/coef
            ch(8,j)=ch(8,j)+ve*t0 !Size
            xe=xe+2.0*ve*t0*ch(9,j)    
            dmass=(2.0*ve*t0)*ch(9,j)*coef/0.8
		  ch(7,j)=mass/area ! density
		   CALL Alloc(ii,'stem',mass,dmass,Sp,SL,SS,SR,
     +			Mleaf/1000.0,volume,Mroot/1000.0,d13Cps,d13CstL,
     +			d13CstS,d13CstR,ch(10,j),ch(10,j),d13CC,dDps,
     +			dDstL,dDstS,dDstR,ch(11,j),ch(11,j),dDC,d18Ops,
     +			d18OstL,d18OstS,d18OstR,ch(12,j),ch(12,j),d18OC,
     +			d13CstLAr,d13CstSAr,d13CstRAr,dDstLAr,dDstSAr,dDstRAr,
     +			d18OstLAr,d18OstSAr,d18OstRAr,SuLAr,SuSAr,SuRAr)
c
	        IF(op(12).EQ.2.AND.op(13).NE.1)WRITE(45,'(''  Cell''
     .       ,I3,'' Enlarging Cell ve'',f6.3,'' vemin'',f6.3,'' cdist'',
     .       f7.2,'' size'',f6.2)')J,ve,b(42),cdist,ch(8,j)
          END IF
       CASE('m')   
C ******************************
C  cell in maturation stage 
C ****************************** 
          cellar=b(3)*ch(8,j)
          potwall=b(4)+(b(5)-b(4))*EXP(-b(63)*(ch(8,j)-b(1)))
	    IF(potwall.GT.cellar-cellar*b(6))THEN
            potwall=cellar-cellar*b(6)
          ENDIF  	   
          Gm=Gr(12)*Gr(11)*Gr(10)
          vm=rate_m(b,ch(4,j),potwall,ctm,gm)
	    ch(4,j)=ch(4,j)+1  !Days in Maturation zone                   
          IF(vm.LE.b(62))THEN 
! --------------------- death of cell
            state(j)='d'
            ch(5,j)=time  !Time of death  
	        IF(op(12).EQ.2.AND.op(13).NE.1)WRITE(45,'(''  Cell''
     .       ,I3,'' Cell is Dead >> vm'',f6.3,'' vmmin'',f6.3,
     .       '' wall'',f5.2,'' size'',f6.2)')J,vm,b(62),ch(9,j),ch(8,j)
          ELSE
C ---------------------  grows cell wall (area)
            cellar=b(3)*ch(8,j)
	      carea=2.0*ch(9,j)*(ch(8,j)+b(3)-2.0*ch(9,j))
            prevwall=ch(9,j)
	      ch(9,j)=ch(9,j)+vm*t0 !Wall thickness
	      area=2.0*ch(9,j)*(ch(8,j)+b(3)-2.0*ch(9,j))
	      darea=(area-carea)
            arlimit=cellar-b(6)*cellar
 	      IF(arlimit.LT.area)THEN
! --------------------- death of cell
              state(j)='d'
              vmpc=SQRT(area-arlimit)/SQRT(darea)
              ch(9,j)=ch(9,j)-(ch(9,j)-prevwall)*vmpc
	        vm=vm*vmpc
	        area=2.0*ch(9,j)*(ch(8,j)+b(3)-2.0*ch(9,j))
	        darea=(area-carea)
              xm=xm+darea     
              dmass=darea*coef/0.8
		    mass=carea*coef
		    ch(7,j)=mass/area ! density
		    CALL Alloc(ii,'stem',mass,dmass,Sp,SL,SS,SR,
     +			Mleaf/1000.0,volume,Mroot/1000.0,d13Cps,d13CstL,
     +			d13CstS,d13CstR,ch(10,j),ch(10,j),d13CC,dDps,
     +			dDstL,dDstS,dDstR,ch(11,j),ch(11,j),dDC,d18Ops,
     +			d18OstL,d18OstS,d18OstR,ch(12,j),ch(12,j),d18OC,
     +			d13CstLAr,d13CstSAr,d13CstRAr,dDstLAr,dDstSAr,dDstRAr,
     +			d18OstLAr,d18OstSAr,d18OstRAr,SuLAr,SuSAr,SuRAr)
	        
              ch(5,j)=time  !Time of death  
	          IF(op(12).EQ.2.AND.op(13).NE.1)THEN
			    WRITE(45,'(''  Cell''
     .            ,I3,'' Cell Dead <wall too thick>> vm'',f6.3,'' wall''
     .            ,f5.2,'' size'',f6.2,'' area'',f8.2,
     .            '' limit'',f8.2)')J,vm,ch(9,j),ch(8,j),area,
     .             arlimit
	          END IF
              GO TO 150
	      END IF
	      darea=(area-carea)
            xm=xm+darea     
            dmass=darea*coef/0.8
		  mass=carea*coef
		  ch(7,j)=mass/area ! density
		   CALL Alloc(ii,'stem',mass,dmass,Sp,SL,SS,SR,
     +			Mleaf/1000.0,volume,Mroot/1000.0,d13Cps,d13CstL,
     +			d13CstS,d13CstR,ch(10,j),ch(10,j),d13CC,dDps,
     +			dDstL,dDstS,dDstR,ch(11,j),ch(11,j),dDC,d18Ops,
     +			d18OstL,d18OstS,d18OstR,ch(12,j),ch(12,j),d18OC,
     +			d13CstLAr,d13CstSAr,d13CstRAr,dDstLAr,dDstSAr,dDstRAr,
     +			d18OstLAr,d18OstSAr,d18OstRAr,SuLAr,SuSAr,SuRAr)
c
	        IF(op(12).EQ.2.AND.op(13).NE.1)WRITE(45,'(''  Cell''
     .        ,I3,'' Wall thickening vm'',f6.3,'' vmmin'',f6.3,
     .        '' wall'',f5.2,'' size'',f6.2,'' area'',f8.2,'' limit'',
     .        f8.2)')J,vm,b(62),ch(9,j),ch(8,j),area,cellar-b(6)*cellar
          END IF
       CASE default
      END SELECT
 150  j=j+1 
      IF(j.LE.num(1)+ndiv.AND.j.LE.1000)GOTO 120 ! processes next cell  
      num(1)=num(1)+ndiv
C  *************************************************************************     
C chechs all cells but initial cell
C Checks the whole file for numbers and any gaps or discontinuities    
C Checks state of previous cell, if different then change it to same state
C  *************************************************************************  
      IF(op(3).GT.0)THEN   
      DO j=2,num(1)
        w=state(j)
        SELECT CASE (w)
          CASE ('c')
	      IF(op(3).EQ.1.OR.op(3).EQ.4.OR.op(3).EQ.6)THEN
              IF(state(j-1).NE.'c')THEN
                state(j)='e' 
              ENDIF
            ENDIF
          CASE ('e')
	      IF(op(3).EQ.2.OR.op(3).GT.3)THEN
              IF(state(j-1).EQ.'m')THEN
	          IF(op(12).EQ.2.AND.op(13).NE.1)THEN
                WRITE(45,'(''  Cell'',I3,
     .          '' Prev=m Switch to Wall Thick ve'',f6.3,'' vemin'',f5.2
     .          ,'' vm'',f6.3,'' vmmin'',f6.3'' wall'',f5.2,'' size'',
     .          f6.2)')J,ve,b(42),vm,b(62),ch(9,j),ch(8,j)
	          END IF
              ch(4,j)=1.0     ! First day in maturation zone
              state(j)='m'
	        END IF
            END IF
          CASE ('m')
	      IF(op(3).EQ.3.OR.op(3).GT.4)THEN
              IF(state(j-1).EQ.'d')THEN
	          IF(op(12).EQ.2.AND.op(13).NE.1)THEN
			  WRITE(45,'(''  Cell''
     .          ,I3,'' Cell is Dead >> vm'',f6.3,'' vmmin'',f6.3,
     .          '' wall'',f5.2,'' size'',f6.2)')J,vm,b(62),ch(9,j),
     .          ch(8,j)
                ch(5,j)=time  !Time of death  
                state(j)='d'   
                END IF
              END IF
            END IF
          CASE DEFAULT
        END SELECT
      END DO
	END IF
C  determination of the number cells in each zone
      num(2)=0
      num(3)=0
      num(4)=0
      DO i=1,num(1)  
        w=state(i)
        SELECT CASE (w)
          CASE ('c')
             num(2)=num(2)+1       ! number in cambium
          CASE ('e')
             num(3)=num(3)+1       ! number in enlargement
          CASE ('m')
             num(4)=num(4)+1       ! number matureing
          CASE DEFAULT
        END SELECT
      END DO
	Gr(1)=xc*coef/0.8
	Gr(2)=xe*coef/0.8
	Gr(3)=xm*coef/0.8
	Ct= Gc !Not sure why this is redefined here as not used HCF
	Cte=Ge !This is the only place this is defined
	Ctm=Gm !Not sure why this is redefined here as not used HCF
	wallsum=0
      dist=0.
	DO i=1,num(1)
	   Correct(3,i)=ch(10,Correct(2,i))
         w=state(i)
         IF(w.EQ.'c'.OR.w.EQ.'e'.OR.w.EQ.'m')dist=dist+ch(8,i)
         IF(w.EQ.'c'.OR.w.EQ.'e'.OR.w.EQ.'m')wallsum=wallsum+ch(9,i)
         IF(b(100).EQ.1.)THEN
           IF(w.EQ.'d')dist=dist+ch(8,i)
           IF(w.EQ.'d')wallsum=wallsum+ch(9,i)
         END IF
      ENDDO
	dist=dist+wallsum
      IF(op(12).EQ.2.AND.op(13).NE.1.AND.cstop.NE.0)WRITE(45,'
     .(''  End of day'',I4,
     .'' Gc,Ge,Gm'',3F5.2,'' Controlling Ring Width'',f7.0)')
     .time,Gc,Ge,Gm,dist
      IF(op(12).EQ.5.AND.op(13).NE.1)THEN
	  WRITE(42,'(I4,150F7.2)')time,
     +	(Correct(1,j),Correct(2,j),Correct(3,j),j=1,50)
	END IF
      END

      FUNCTION rate_min(b,cdist,ct)
      REAL b(100),ct,cdist
      rate_min=b(22)*EXP(b(26)*(cdist-b(27)*
     +         (1.0/b(32)+(1.0-1.0/b(32))*Ct)))  
      END

      FUNCTION rate_division(b,dis,cdist,ct,gc)
      REAL b(100),dis,cdist,ct,gc
C  *************************************************************************     
C  calculates growth rate as function of width of active layer (for early growth)
C  *************************************************************************     
      sl=b(24)*(dis)/(dis+b(28))
C  *************************************************************************     
C  calculates boundries of growth rate
C  *************************************************************************     
      vp=(b(25)-(60.0-cdist)*sl)*b(22)    ! growth rate when conditions optimum
      IF(VP.LE.0)VP=0.0             ! vp cannot exceed a horizontal line
C  *************************************************************************     
C  calculates growth rate as function of limiting factors and crown control
C  *************************************************************************     
      rate_division=vp*Gc*(1.0/b(31)+(1.0-1.0/b(31))*Ct)
! calc. effect of limiting factors
      END

      FUNCTION rate_e(b,age,s0,potsize,ct,ge)
      REAL b(100),ct,ge,age,potsize,s0
      rate=b(46)*(potsize-s0)*EXP(-b(46)*age)
	rate_e=rate*ge*(1.0/b(51)+(1.0-1.0/b(51))*Ct)
      END
       
      FUNCTION rate_m(b,age,potwall,ctm,gm)
      REAL b(100),age,potwall,ctm,gm
      rate=b(64)*(potwall-b(4))*EXP(-b(64)*age)
	rate_m=rate*gm*(1.0/b(71)+(1.0-1.0/b(71))*Ctm)
      END 

